#! /usr/bin/env python
# -*- coding: iso-8859-1 -*-
# 2008-01-07 by Krzysztof Kaminski OA UAM

import os
import commands
import string
import time
import math
import re

#czytanie pliku z parametrami
g=open('red6.py.cmd', 'r')
i=int(0)
for cmd in g.readlines():
  if i==0: plik_fxcor_output=cmd[:-1]
  if i==1: plik_rv_txt=cmd[:-1]
  if i==2: plik_rv_agr=cmd[:-1]
  if i==3: plik_rv_ps=cmd[:-1]
  if i==4: plik_rv_name=cmd[:-1]
  if i==5: phase_max=float(cmd[:-1]) #max faza na rysunku 1.0 lub 2.0
  if i==6: rv_auto_swap=cmd[:-1] #auto-swap rv1 and rv2 (for binary systems)
  if i==7: rv_plot_type=cmd[:-1] #phase, HJD or both: plot rv(phase), rv(HJD) or both
  if i==8: P0=cmd[:-1]
  if i==9: T0=cmd[:-1]
  if i==10: plot_title=cmd[:-1]
  if i==11: tell_corr=cmd[:-1] #if telluric lines cross-corellation should be used to correct rv
  if i==12: rv_type=cmd[:-1] #save rv type: heliocentric, relative
  i=i+1
plik_fxcor_output_tell=plik_fxcor_output+"_tell.txt"
plik_fxcor_output=plik_fxcor_output+".txt"
g.close()

d=open('list_obj_red6.txt', 'r')
f=open('phases.txt', 'r')

#liczenie ile bylo skladnikow ukladu dla danego widma i zapamietanie pierwszej ilosci do porownywania pozniej
i=int(0)   #ilosc znalezionych widm obiektu
ile=int(0) #ile jest skladnikow ukladu
ok=int(1)  #1 oznacza stala ilosc skladnikow ukladu w calym pliku results.txt
for objekt in d.readlines(): #czytamy nazwy plikow obiektow
  j=int(0)
  comm1=str("cat "+plik_fxcor_output+" | grep -c \"" + objekt[:-1] + " \"")
  aaa = commands.getoutput(comm1)
  j=int(aaa)
  i=i+1
  if i==1:
    ile=j
  elif i>1:
    if ile!=j:
      ok=0
  if j==0:
    ok=0
d.seek(0)

#print(" ok= "+str(ok)+"  "+str(i)+" "+str(ile))

#liczenie ile bylo widm obiektow i sprawdzenie czy tyle samo co w pliku results.txt
m=int(0)   #ilosc znalezionych widm obiektu
for objekt in d.readlines(): #czytamy nazwy plikow obiektow
  j=int(0)
  comm1=str("cat phases.txt | grep -c \"" + objekt[:-1] + "\"")
  aaa = commands.getoutput(comm1)
  j=int(aaa)
  m=m+1
  if j==0:
    ok=0
d.seek(0)

#print(" ok= "+str(ok)+" m="+str(m))

#liczenie ile bylo korelacji linii tellurycznych ilosci do porownywania pozniej
if tell_corr=="yes":
  i_tell=int(0)   #ilosc znalezionych widm obiektu
  ile_tell=int(0) #ile jest skladnikow ukladu
  ok_tell=int(1)  #1 oznacza stala ilosc skladnikow ukladu w calym pliku results.txt
  for objekt in d.readlines(): #czytamy nazwy plikow obiektow
    j=int(0)
    comm1=str("cat "+plik_fxcor_output_tell+" | grep -c \"" + objekt[:-1] + " \"")
    aaa = commands.getoutput(comm1)
    j=int(aaa)
    i_tell=i_tell+1
    if i_tell==1:
      ile_tell=j
    elif i_tell>1:
      if ile_tell!=j:
        ok_tell=0
    if j==0:
      ok_tell=0
  d.seek(0)

if (tell_corr=="yes"):
  if (ok_tell!=1) or (i_tell!=m):
    ok=0

#print(" test: "+str(ok)+" "+str(ile)+" "+str(i)+" "+str(m))

if (ok==1) and (ile>0) and (ile<4) and (i==m):

  print("Found: "+str(i)+" specrta with "+str(ile)+" ccf peaks each.")

  #wczytanie pliku phases.txt
  if (plik_rv_txt=="yes"):
    e=open(plik_fxcor_output, 'r')
    k=int(0)
    faza=[0.0]
    hjd=[0.0]
    ha=[0.0]

    for objekt in d.readlines(): #czytamy nazwy plikow obiektow

      #czytamy faze i HJD z pliku z phases.txt
      for wynik in f.readlines(): #czytamy kolejne linijki pliku z wynikami z fxcora
        if re.search(objekt[:-1], wynik[:-1]) != None:
          faza[k]=float(wynik[54:63])
          hjd[k]=float(wynik[36:51])
          ha[k]=float(wynik[64:74])
      f.seek(0)

      faza.append(float(-1000.0))
      hjd.append(float(-1000.0))
      ha.append(float(-1000.0))
      k=k+1

    e.close()
    d.seek(0)

  #wczytanie predkosci linii tellurycznych
  if (tell_corr=="yes"):
    e=open(plik_fxcor_output_tell, 'r')
    k=int(0)
    vrad1tell=[0.0]
    suma=float(0.0)

    for objekt in d.readlines(): #czytamy nazwy plikow obiektow

      #czytamy predkosci radialne z pliku z wynikami z fxcora
      for wynik in e.readlines():
        if re.search(objekt[:-1]+" ", wynik[:-1]) != None:
          vrad1tell[k]=float(wynik[-31:-21])
          suma=suma+vrad1tell[k]
      e.seek(0)

      vrad1tell.append(float(-1000.0))
      k=k+1

    e.close()
    d.seek(0)

  #tworzenie plikow txt z predkosciami radialnymi
  if plik_rv_txt=="yes":
    e=open(plik_fxcor_output, 'r')
    if (tell_corr=="no"): g=open(plik_rv_name+'.txt', 'a')
    if (tell_corr=="yes"): g=open(plik_rv_name+'_t.txt', 'a')
    k=0
    vrad1h=[0.0]
    vrad2h=[0.0]
    vrad3h=[0.0]

    for objekt in d.readlines(): #czytamy nazwy plikow obiektow

      #czytamy predkosci radialne z pliku z wynikami z fxcora
      j=0
      for wynik in e.readlines():
        if re.search(objekt[:-1]+" ", wynik[:-1]) != None:
          j=j+1
          if j==1:
            if rv_type=="heliocentric":
              vrad1h[k]=float(wynik[-20:-9])
            if rv_type=="relative":
              vrad1h[k]=float(wynik[-31:-21])
          elif j==2:
            if rv_type=="heliocentric":
              vrad2h[k]=float(wynik[-20:-9])
            if rv_type=="relative":
              vrad2h[k]=float(wynik[-31:-21])
          elif j==3:
            if rv_type=="heliocentric":
              vrad3h[k]=float(wynik[-20:-9])
            if rv_type=="relative":
              vrad3h[k]=float(wynik[-31:-21])
      e.seek(0)

      #przestawiamy vrad1 i vrad2 gdy to chciane i potrzebne
      if (j!=1) and (rv_auto_swap=="yes"):
        if (faza[k]<0.5) and (vrad1h[k]>vrad2h[k]):
          temp=vrad1h[k]
          vrad1h[k]=vrad2h[k]
          vrad2h[k]=temp
        if (faza[k]>=0.5) and (vrad1h[k]<vrad2h[k]):
          temp=vrad1h[k]
          vrad1h[k]=vrad2h[k]
          vrad2h[k]=temp

      #zapisanie pierwszej linijki z objasnieniem kolumn
      if ((k==0) and (tell_corr=="no")):
        g.write('#Object heliocentric rv.\n')
        if j==1:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1\n')
        elif j==2:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1      rv_hel2\n')
        elif j==3:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1      rv_hel2      rv_hel3\n')
      if ((k==0) and (tell_corr=="yes")):
        g.write('#Object heliocentric rv before and after correction based on telluric lines rv.\n')
        if j==1:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1     tell_corr     rv_hel1_corr\n')
        elif j==2:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1      rv_hel2     tell_corr     rv_hel1_corr     rv_hel2_corr\n')
        elif j==3:
          g.write('#             file name              HJD                  phase      HA (hours)   rv_hel1      rv_hel2      rv_hel3     tell_corr     rv_hel1_corr     rv_hel2_corr     rv_hel3_corr\n')

      #zapisywanie do pliku
      if (tell_corr=="no"):
        if j==1:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k]))
        elif j==2:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k],vrad2h[k]))
        elif j==3:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f %10.4f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k],vrad2h[k],vrad3h[k]))
      if (tell_corr=="yes"):
        if j==1:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f %10.4f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k],vrad1tell[k],vrad1h[k]-vrad1tell[k]))
        elif j==2:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f %10.4f %10.4f %10.4f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k],vrad2h[k],vrad1tell[k],vrad1h[k]-vrad1tell[k],vrad2h[k]-vrad1tell[k]))
        elif j==3:
          g.write('%30s %20.6f %14.6f %12.6f %10.4f %10.4f %10.4f %10.4f %10.4f %10.4f %10.4f\n' % (objekt[:-1],hjd[k],faza[k],ha[k],vrad1h[k],vrad2h[k],vrad3h[k],vrad1tell[k],vrad1h[k]-vrad1tell[k],vrad2h[k]-vrad1tell[k],vrad3h[k]-vrad1tell[k]))

      vrad1h.append(float(-1000.0))
      vrad2h.append(float(-1000.0))
      vrad3h.append(float(-1000.0))
      k=k+1

    g.close()
    d.seek(0)


  #tworzenie pliku typu agr
  if plik_rv_agr=="yes":
    ile=k;
    #aplikowanie korekty telurycznej gdy trzeba
    if (tell_corr=="yes"):
      for k in range(ile):
        if j==1:
          vrad1h[k]=vrad1h[k]-vrad1tell[k]
        elif j==2:
          vrad1h[k]=vrad1h[k]-vrad1tell[k]
          vrad2h[k]=vrad2h[k]-vrad1tell[k]
        elif j==3:
          vrad1h[k]=vrad1h[k]-vrad1tell[k]
          vrad2h[k]=vrad2h[k]-vrad1tell[k]
          vrad3h[k]=vrad3h[k]-vrad1tell[k]

    #szukanie max i min wartosci vrad
    vmin=float(10000000.0)
    vmax=float(-10000000.0)
    for n in range(k):
      if vrad1h[n]>vmax:
        vmax=vrad1h[n]
      if vrad1h[n]<vmin:
        vmin=vrad1h[n]
      if j>1:
        if vrad2h[n]>vmax:
          vmax=vrad2h[n]
        if vrad2h[n]<vmin:
          vmin=vrad2h[n]
      if j>2:
        if vrad3h[n]>vmax:
          vmax=vrad3h[n]
        if vrad3h[n]<vmin:
          vmin=vrad3h[n]
    #poszerzenie zakresu o ok 15%
    vmin=vmin-0.15*math.fabs(vmax-vmin)
    vmax=vmax+0.15*math.fabs(vmax-vmin)

    #rysowanie wykresow rv(phase) do plikow agr i ps
    if ((rv_plot_type=="phase") or (rv_plot_type=="both")):

      #tworzenie pliku typu agr
      if (tell_corr=="no"): comm1=str("cp red6.agr1 "+plik_rv_name+"_ph.agr")
      if (tell_corr=="yes"): comm1=str("cp red6.agr1 "+plik_rv_name+"_t_ph.agr")
      aaa = commands.getoutput(comm1)
      print(aaa)
      time.sleep(1)

      if (tell_corr=="no"): h=open(plik_rv_name+'_ph.agr', 'a')
      if (tell_corr=="yes"): h=open(plik_rv_name+'_t_ph.agr', 'a')
      h.write('@    title \"%s\"\n' % (plot_title))
      h.write('@    world 0, %6.1f, %3.1f, %5.1f\n' % (vmin,phase_max,vmax))
      h.write('@    xaxis  label \"phase\"\n')
      if rv_type=="heliocentric":
        h.write('@    yaxis  label "heliocentric rv [km/s]"\n')
      if rv_type=="relative":
        h.write('@    yaxis  label "relative rv [km/s]"\n')
      h.write('@    subtitle \"P=%s  T0=%s\"\n' % (P0,T0))
      h.write('@    xaxis  tick major 0.2\n')
      h.write('@    xaxis  ticklabel format general\n')
      h.write('@    xaxis  ticklabel prec 5\n')
      if (math.fabs(vmax-vmin)<0.5): h.write('@    yaxis  tick major 0.1\n')
      if (math.fabs(vmax-vmin)>=0.5) and (math.fabs(vmax-vmin)<2.0): h.write('@    yaxis  tick major 0.25\n')
      if (math.fabs(vmax-vmin)>=2.0) and (math.fabs(vmax-vmin)<8.0): h.write('@    yaxis  tick major 1.0\n')
      if (math.fabs(vmax-vmin)>=8.0) and (math.fabs(vmax-vmin)<32.0): h.write('@    yaxis  tick major 4.0\n')
      if (math.fabs(vmax-vmin)>=32.0) and (math.fabs(vmax-vmin)<128.0): h.write('@    yaxis  tick major 16.0\n')
      if (math.fabs(vmax-vmin)>=128.0): h.write('@    yaxis  tick major 64.0\n')
      h.write("@target G0.S0\n")
      h.write("@type xy\n")
      for n in range(k):
        h.write('%14.6f %14.6f\n' % (faza[n],vrad1h[n]))
      if phase_max>1.0:
        for n in range(k):
          h.write('%14.6f %14.6f\n' % (faza[n]+1.0,vrad1h[n]))
      h.write("&\n")
      if j>1:
        h.write("@target G0.S1\n")
        h.write("@type xy\n")
        for n in range(k):
          h.write('%14.6f %14.6f\n' % (faza[n],vrad2h[n]))
        if phase_max>1.0:
          for n in range(k):
            h.write('%14.6f %14.6f\n' % (faza[n]+1.0,vrad2h[n]))
        h.write("&\n")
      if j>2:
        h.write("@target G0.S2\n")
        h.write("@type xy\n")
        for n in range(k):
          h.write('%14.6f %14.6f\n' % (faza[n],vrad3h[n]))
        if phase_max>1.0:
          for n in range(k):
            h.write('%14.6f %14.6f\n' % (faza[n]+1.0,vrad3h[n]))
        h.write("&")
      h.close()

      #tworzenie pliku typu ps
      if plik_rv_ps=="yes":
        time.sleep(1)
        if (tell_corr=="no"): comm1=str("xmgrace -hardcopy "+plik_rv_name+"_ph.agr")
        if (tell_corr=="yes"): comm1=str("xmgrace -hardcopy "+plik_rv_name+"_t_ph.agr")
        aaa = commands.getoutput(comm1)
        print(aaa)

    #rysowanie wykresow rv(HJD) do plikow agr i ps
    if ((rv_plot_type=="HJD") or (rv_plot_type=="both")):

      #szukanie max i min wartosci HJD
      HJDmin=float(10000000.0)
      HJDmax=float(-10000000.0)
      for n in range(k):
        if hjd[n]>HJDmax:
          HJDmax=hjd[n]
        if hjd[n]<HJDmin:
          HJDmin=hjd[n]
      #poszerzenie zakresu o ok 5%
      HJDmin=HJDmin-0.05*math.fabs(HJDmax-HJDmin)
      HJDmax=HJDmax+0.05*math.fabs(HJDmax-HJDmin)

      #tworzenie pliku typu agr
      if (tell_corr=="no"): comm1=str("cp red6.agr1 "+plik_rv_name+"_hjd.agr")
      if (tell_corr=="yes"): comm1=str("cp red6.agr1 "+plik_rv_name+"_t_hjd.agr")
      aaa = commands.getoutput(comm1)
      print(aaa)
      time.sleep(1)

      if (tell_corr=="no"): h=open(plik_rv_name+'_hjd.agr', 'a')
      if (tell_corr=="yes"): h=open(plik_rv_name+'_t_hjd.agr', 'a')
      h.write('@    title \"%s\"\n' % (plot_title))
      h.write('@    world %13.5f, %6.1f, %13.5f, %5.1f\n' % (HJDmin,vmin,HJDmax,vmax))
      h.write('@    xaxis  label \"HJD\"\n')
      if rv_type=="heliocentric":
        h.write('@    yaxis  label "heliocentric rv [km/s]"\n')
      if rv_type=="relative":
        h.write('@    yaxis  label "relative rv [km/s]"\n')
      h.write('@    subtitle \"\"\n')
      if (math.fabs(HJDmax-HJDmin)<0.5): h.write('@    xaxis  tick major 0.1\n')
      if (math.fabs(HJDmax-HJDmin)>=0.5) and (math.fabs(HJDmax-HJDmin)<2.0): h.write('@    xaxis  tick major 0.25\n')
      if (math.fabs(HJDmax-HJDmin)>=2.0) and (math.fabs(HJDmax-HJDmin)<8.0): h.write('@    xaxis  tick major 1.0\n')
      if (math.fabs(HJDmax-HJDmin)>=8.0) and (math.fabs(HJDmax-HJDmin)<32.0): h.write('@    xaxis  tick major 4.0\n')
      if (math.fabs(HJDmax-HJDmin)>=32.0) and (math.fabs(HJDmax-HJDmin)<128.0): h.write('@    xaxis  tick major 16.0\n')
      if (math.fabs(HJDmax-HJDmin)>=128.0): h.write('@    xaxis  tick major 64.0\n')
      if (math.fabs(vmax-vmin)<0.5): h.write('@    yaxis  tick major 0.1\n')
      if (math.fabs(vmax-vmin)>=0.5) and (math.fabs(vmax-vmin)<2.0): h.write('@    yaxis  tick major 0.25\n')
      if (math.fabs(vmax-vmin)>=2.0) and (math.fabs(vmax-vmin)<8.0): h.write('@    yaxis  tick major 1.0\n')
      if (math.fabs(vmax-vmin)>=8.0) and (math.fabs(vmax-vmin)<32.0): h.write('@    yaxis  tick major 4.0\n')
      if (math.fabs(vmax-vmin)>=32.0) and (math.fabs(vmax-vmin)<128.0): h.write('@    yaxis  tick major 16.0\n')
      if (math.fabs(vmax-vmin)>=128.0): h.write('@    yaxis  tick major 64.0\n')
      h.write('@    xaxis  ticklabel format decimal\n')
      h.write('@    xaxis  ticklabel prec 1\n')
      h.write("@target G0.S0\n")
      h.write("@type xy\n")
      for n in range(k):
        h.write('%14.6f %14.6f\n' % (hjd[n],vrad1h[n]))
      h.write("&\n")
      if j>1:
        h.write("@target G0.S1\n")
        h.write("@type xy\n")
        for n in range(k):
          h.write('%14.6f %14.6f\n' % (hjd[n],vrad2h[n]))
        if phase_max>1.0:
          for n in range(k):
            h.write('%14.6f %14.6f\n' % (hjd[n]+1.0,vrad2h[n]))
        h.write("&\n")
      if j>2:
        h.write("@target G0.S2\n")
        h.write("@type xy\n")
        for n in range(k):
          h.write('%14.6f %14.6f\n' % (hjd[n],vrad3h[n]))
        if phase_max>1.0:
          for n in range(k):
            h.write('%14.6f %14.6f\n' % (hjd[n]+1.0,vrad3h[n]))
        h.write("&")
      h.close()

      #tworzenie pliku typu ps
      if plik_rv_ps=="yes":
        time.sleep(1)
        if (tell_corr=="no"): comm1=str("xmgrace -hardcopy "+plik_rv_name+"_hjd.agr")
        if (tell_corr=="yes"): comm1=str("xmgrace -hardcopy "+plik_rv_name+"_t_hjd.agr")
        aaa = commands.getoutput(comm1)
        print(aaa)

else:
  print("Error reading data files:\n "+plik_fxcor_output+" or "+plik_fxcor_output_tell+" or phases.txt")

d.close()
f.close()

